//Diseo y Programacin Orientada al Objeto
//Proyecto Personal - "Agenda del Objeto"
//Nicols Cheker C
//Rol: 9892002-1
//Archivo: fileservices.cpp - Mdulo con mtodos privados de servicios de manejo de archivos

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "tipos.h"

/******************************************************** FSize ****************************************************************/
//Mtodo privado: FSize - Retorna el tamao, en registros, del archivo de datos
//Precondiciones: El archivo existe
//Valor devuelto: El tamao del archivo
long PersonaClass::FSize ()
{
  long tam;

  DataF = fopen (FName, "r");                   //Abrir el archivo
  fseek (DataF, 0L, SEEK_END);                  //Ir al final
  tam = ftell(DataF)/sizeof(struct PersonaT);   //N de registros = tamao en bytes / tamao del registro
  fclose (DataF);                               //Cerrar el archivo...
  return (tam);                                 //Devolver el tamao.
}//EndPersonaClass::FSize

/***************************************************** WDataToFile *************************************************************/
//Mtodo privado: WDataToFile - Escribe un nuevo registro al archivos de datos, ordenado por apellido, en primer lugar, y en 2do.
//lugar por nombre.
//Precondiciones: La propiedad "Persona" de la clase contiene los datos a almacenar; el archivo de datos existe
//Postcondiciones: Si NO existe un registro con idnticos nombre y apellido, el nuevo dato es almacenado. Si no, no.
//Valor devuelto: 0 - Operacin exitosa; 1 - Fallo por repeticin de apellido Y nombre.
int PersonaClass::WDataToFile ()
{
  struct PersonaT buffer;       //Registro auxiliar
  int maslargo;                 //Largo del string ms largo entre buffer.Apellido y Persona.Apellido (o .Nombre)
  int avanzar = -1;             //Cuando avanzar < 0, aun no llegamos al lugar correcto para guardar los datos.
  int repetido = 0;             //Si vale 1, el registro que se intenta almacenar ya est en el archivo
  long pos,                     //Posicin del elemento a agregar
       endpos;                  //Posicin del ltimo elemento+1

  DataF = fopen (FName, "r+");                                  //Abrir archivo para lecto-escritura
  while (!(feof(DataF)) && (avanzar < 0))                       //Mientras no llegamos al EOF o el Rut no encuentra su lugar...
    {
      pos = ftell (DataF);                                      //Guardar posicin actual en el archivo.
      fread (&buffer, sizeof(struct PersonaT), 1, DataF);       //Leer elemento del archivo
      if (strlen(Persona.Apellido) > strlen(buffer.Apellido))   //Asignar a maslargo el largo (en chars) del string
        maslargo = strlen(Persona.Apellido);                    //ms largo
       else
         maslargo = strlen(buffer.Apellido);
      avanzar = memcmp (buffer.Apellido, Persona.Apellido, maslargo);   //Comparamos los Apellidos.
      if (avanzar == 0)                                         //Si los apellidos son iguales, entonces...
        {
          if (strlen(Persona.Apellido) > strlen(buffer.Apellido))       //Asignar a maslargo el largo (en chars) del string
            maslargo = strlen(Persona.Apellido);                        //ms largo
           else
             maslargo = strlen(buffer.Apellido);
          avanzar = memcmp (buffer.Nombre, Persona.Nombre, maslargo);   //...comparamos los Nombres
          if (avanzar == 0)                                     //Si el dato ya est en el archivo...
            {
              avanzar = 1;                                      //...salir del loop...
              repetido = 1;                                     //...e indicar la condicin de error
            }//EndIf
        }//EndIf
    }//EndWhile.

  //En este punto, pueden ocurrir dos cosas: 1) El registro est repetido. En ese caso, se sale de la funcin y se devuelve un 1
  //2) Si el registro no se encuentra, entonces estamos en el lugar en que debe ser agregado. Para eso, abrimos un espacio y lo
  //insertamos.

  if (repetido == 0)                                                    //No se encuentra el registro, as que insertamos el nuevo dato
    {
      fseek (DataF, 0L, SEEK_END);                                      //Ir al final del archivo...
      endpos = ftell (DataF);                                           //Obtener posicin
      if (pos < endpos)                                                 //Si la nueva info NO debe ser agregada al final...
        {
          while (endpos > pos)                                          //...ir hacia atrs hasta llegar al lugar requerido...
            {
              fseek (DataF, -sizeof(struct PersonaT), SEEK_CUR);        //...y, mientras tanto, vamos moviendo todo un lugar pa'delante...
              fread (&buffer, sizeof(struct PersonaT), 1, DataF);       //...Para esto es necesario: Leer elemento del archivo...
              fwrite (&buffer, sizeof(struct PersonaT), 1, DataF);      //..escribir elemento al archivo...
              fseek (DataF, -(2*sizeof(struct PersonaT)), SEEK_CUR);    //...moverse otra vez pa'trs...
              endpos = ftell (DataF);                                   //Y vichamos a ver dnde estamos parados...
            }//EndWhile
        }//EndIf
      fwrite (&Persona, sizeof(struct PersonaT), 1, DataF);             //Ufff!! Estamos listos para guardar la nueva informacin...
    }//EndIf

  fclose (DataF);                                                       //Cerrar el archivo
  return (repetido);                                                    //Devolver el resultado de la operacin.
}//EndPersonaClass::WDataToFile

/**************************************************** RDataFromFile ************************************************************/
//Mtodo privado: RDataFromFile - Lee un registro del archivo, utilizando uno de 4 criterios posibles, definido por SMode:
//1) Si SMode = 0, entonces se lee el reigstro nmero RegNo (1er registro es RegNo = 0). Esto es til para listar todos los regs.
//2) Si SMode = 1, entonces busca por Apellido (en Ape) y Nombre (en Nom), y RegNo es un don't care
//3) Si SMode = 2, entonces busca la RegNo-sima ocurrencia de un registro especificado por Apellido (RegNo = 1 es la 1era. ocurrencia)
//4) Si SMode = 3, entonces busca la RegNo-sima ocurrencia de un registro especificado por Nombre   (idem)
//Precondiciones: El archivo de datos existe
//Valor devuelto: Si SMode = 0: 0 = Ok, -1 = RegNo est fuera de rango
//                Si SMode = 1..3: nmero de registro, o -1 = No se encuentra el registro requerido.
//                Para cualquier SMode, si el valor devuelto es -2, el archivo est vaco.
long PersonaClass::RDataFromFile (int SMode, long RegNo, char Ape[36], char Nom[36])
{
  long resultado = -1;
  int avanzar = -1;
  int ocurrencia = 0;
  int maslargo;
  long tam;

  tam = FSize();                                                //Obtener tamao del archivo
  if (tam == 0)                                                 //Si est vaco...
    {
      resultado = -2;                                           //...setear resultado
    }//Endif
   else
     {
       DataF = fopen (FName, "r");                              //Abrir el archivo para lectura
       if (SMode == 0)                                          //Si se pide buscar por RegNo...
         {
           if (RegNo < tam)                                     //...y RegNo est dentro del rango del archivo...
             {
               fseek (DataF, RegNo*sizeof(Persona), SEEK_SET);  //...entonces ir a RegNo...
               fread (&Persona, sizeof(Persona), 1, DataF);     //...y leer el dato
               resultado = 0;                                   //Setear resultado como encontrado
             }//EndIf
         }//EndIf
        else
          if (SMode == 1)                                       //Si se pide buscar por apellido Y nombre...
            {
              while (!feof(DataF) && (avanzar < 0))             //...repetir mientras hayan + reg's y no hayamos encontrado el nuestro
                {
                  fread (&Persona, sizeof(struct PersonaT), 1, DataF);          //Leer un registro
                  if (!feof(DataF))                                             //Si se ley un registro vlido....
                    {
                      if (strlen(Persona.Apellido) > strlen(Ape))               //Asignar a maslargo el largo (en chars) del string
                        maslargo = strlen(Persona.Apellido);                    //ms largo
                       else
                         maslargo = strlen(Ape);
                      avanzar = memcmp (Persona.Apellido, Ape, maslargo);       //...comparamos los Apellidos.
                      if (avanzar == 0)                                         //Si los apellidos coinciden...
                        {
                          if (strlen(Persona.Nombre) > strlen(Nom))             //Asignar a maslargo el largo (en chars) del string
                            maslargo = strlen(Persona.Nombre);                  //ms largo
                           else
                             maslargo = strlen(Nom);
                          avanzar = memcmp (Persona.Nombre, Nom, maslargo);     //...comparamos los nombres.
                          if (avanzar == 0)                                     //Si es el registro requerido...
                            {
                              resultado = ftell(DataF)/sizeof(struct PersonaT); //...devolver posicin
                            }//EndIf
                        }//EndIf
                    }//EndIf
                }//EndWhile
            }//EndElseIf
        else
          if ((SMode == 2) || (SMode == 3))                     //Si se pide buscar por apellido o por nombre...
            {
              while (!feof(DataF) && (ocurrencia < RegNo))      //Mientras no se llega a EOF y no se encuentra la ocurrencia deseada...
                {
                  fread (&Persona, sizeof(struct PersonaT), 1, DataF);          //Leer un registro
                  if (!feof(DataF))                                             //Si se ley un registro vlido....
                    {
                     if (SMode == 2)                                            //Si se busca por apellido...
                       {
                        if (strlen(Persona.Apellido) > strlen(Ape))             //Asignar a maslargo el largo (en chars) del string
                          maslargo = strlen(Persona.Apellido);                  //ms largo
                         else
                           maslargo = strlen(Ape);
                        avanzar = memcmp (Persona.Apellido, Ape, maslargo);     //...comparamos los Apellidos.
                       }//EndIf
                      else
                       if (SMode == 3)                                          //Si se busca por nombre...
                         {
                          if (strlen(Persona.Nombre) > strlen(Nom))             //Asignar a maslargo el largo (en chars) del string
                            maslargo = strlen(Persona.Nombre);                  //ms largo
                           else
                             maslargo = strlen(Nom);
                          avanzar = memcmp (Persona.Nombre, Nom, maslargo);     //...comparamos los nombres
                         }//EndElseIf
                      if (avanzar == 0)                                         //Si el criterio de comparacin coincide...
                        {
                          ocurrencia++;                                         //Entonces encontramos una nueva ocurrencia
                          if (ocurrencia == RegNo)                              //Si es la ocurrencia que se pide...
                            {
                              resultado = ftell(DataF)/sizeof(struct PersonaT); //...devolver posicin
                            }//EndIf
                        }//EndIf
                    }//EndIf
                }//EndWhile
            }//EndElseIf
       fclose (DataF);                                                          //Cerrar archivo
     }//EndElse
  return (resultado);                                                           //Retornar resultado de la bsqueda
}//EndPersonaClass::RDataFromFile

/**************************************************** DDataFromFile ************************************************************/
//Mtodo privado: DDataFromFile - Elimina del archivo de datos un registro determinado por su posicin en el archivo.
//Precondiciones: RegNo es el nmero de registro (RegNo = 0 es el primer reg.), y est dentro del rango del archivo. El archivo existe.
//                El archivo no est vaco.
//Postondiciones: El registro es eliminado del archivo
void PersonaClass::DDataFromFile (long RegNo)
{
  long truncpos;
  int FD;

  DataF = fopen (FName, "r+");                                  //Abrir para lecto-escritura
  fseek (DataF, (RegNo+1)*sizeof(struct PersonaT), SEEK_SET);   //Ir a la posicin a borrar+1.
  while (!feof(DataF))                                          //Primero hay que mover todo para atrs
    {
      fread (&Persona, sizeof(struct PersonaT), 1, DataF);              //Leer elemento del archivo
      if (!feof(DataF))                                                 //Si no se nos acab el archivo...
        {
          fseek (DataF, -(2*sizeof(struct PersonaT)), SEEK_CUR);        //...moverse 2 lugares para atrs...
          fwrite (&Persona, sizeof(struct PersonaT), 1, DataF);         //..escribir elemento al archivo...
          fseek (DataF, sizeof(struct PersonaT), SEEK_CUR);             //...moverse 1 lugar para adelante...
        }//EndIf
    }//EndWhile
  //Listos para truncar el archivo en la posicin final.
  fseek (DataF, -(sizeof(struct PersonaT)), SEEK_END);  //Primero, vamos al ltimo registro del archivo...
  truncpos = ftell(DataF);                              //Guardamos el nuevo largo del archivo, que es menor.
  fclose (DataF);                                       //Como esto se pudo pesado en runtime, hubo que usar un truco. No s
  FD = open (FName, O_WRONLY);                          //por qu la funcin "truncate" no funcion, y para poder truncar el archivo
  ftruncate (FD, truncpos);                             //hubo que usar "ftruncate" (parece que es ms "estandar" que truncate),
  close (FD);                                           //y para no tener que modificar todo el cdigo, mejor puse un descriptor de
                                                        //tipo "int" local a esta funcin, y me manej con eso.
}//EndPersonClass::DDataFromFile

/***************************************************** MDataInFile *************************************************************/
//Mtodo privado: MDataInFile - Sobreescribe el registro almacenado en la posicin RegNo por los nuevos datos presentes en Persona
//Precondiciones: RegNo es el nmero de registro (RegNo = 0 es el primer reg.), y est dentro del rango del archivo. El archivo existe.
//                El archivo no est vaco.
//Postondiciones: El registro es modificado
void PersonaClass::MDataInFile (long RegNo)
{
  DataF = fopen (FName, "r+");                                  //Abrir para lecto-escritura
  fseek (DataF, RegNo*sizeof(struct PersonaT), SEEK_SET);       //Ir a la posicin a modificar.
  fwrite (&Persona, sizeof(struct PersonaT), 1, DataF);         //..modificar el registro.
  fclose (DataF);                                               //Cerrar el archivo.
}//EndPersonClass::DDataFromFile


