//Diseo y Programacin Orientada al Objeto
//Proyecto Personal - "Agenda del Objeto"
//Nicols Cheker C
//Rol: 9892002-1
//Archivo: personmethods.cpp - Implementacin de los mtodos pblicos de la clase

#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include "tipos.h"

/***************************************************** Constructor *************************************************************/
PersonaClass::PersonaClass()
{
  //La forma ms simple de crear un archivo si no existe, y no eliminar el existente (si es el caso)
  DataF = fopen (FName, "a+");          //Abrir o crear el archivo
  fclose (DataF);                       //Cerrarlo.
}

/****************************************************** Destructor *************************************************************/
PersonaClass::~PersonaClass()
{

}

/****************************************************** ShowData ***************************************************************/
//Mtodo privado ShowData - Muestra las propiedades del objeto por consola
void PersonaClass::ShowData()
{
  cout << "Datos de la persona:\n\n";
  cout << "  Nombre:    " << Persona.Nombre << "\n";
  cout << "  Apellido:  " << Persona.Apellido << "\n";
  cout << "  Direccin: " << Persona.Direccion << "\n";
  cout << "  Ciudad:    " << Persona.Ciudad << "\n";
  cout << "  Telfono:  " << Persona.Telefono << "\n";
  cout << "  Fax:       " << Persona.Fax << "\n";
  cout << "  e-mail:    " << Persona.EMail << "\n";
  cout << "  Ocupacin: " << Persona.Ocupacion << "\n\n\n";
}//EndPersonaClass::ShowData

/******************************************************* GetData ***************************************************************/
//Mtodo privado GetData - Obtiene datos de la consola
//Parmetro "mode": Si mode = 0, entonces se piden TODOS los datos (necesario al ingresar nuevos registros). Si mode = 1, entonces
//se pide todo, excepto apellido y nombre (necesario para modificar registros).
//Valor devuelto: Si mode = 0, enconces la funcin devuelve 0 si se han ingresado datos, o 1 si no se han ingresado datos.
//Si mode = 1, el valor devuelto es 0.
int PersonaClass::GetData(int mode)
{
  int stop = 0;

  if (mode == 0)
    {
      cout << "Ingrese el apellido (ENTER para terminar): ";    //Pedir Apellido
      cin.get (Persona.Apellido, 36);                           //Leer hasta 35 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      stop = (strlen(Persona.Apellido) == 0);                   //Terminar si el largo es 0 (slo se digit ENTER)
      if (!stop)                                                //Si se ingres apellido....
        {
          cout << "Ingrese el nombre: ";                        //Entonces, ahora s pedimos el nombre...
          cin.get (Persona.Nombre, 36);                         //...leer hasta 35 chars. + '\0' de la consola
          cin.ignore (256, '\n');
        }//EndIF
    }//EndIf
  if (!stop)                                                    //Si el usuario NO indic final...
    {
      cout << "Ingrese la direccin: ";                         //Luego, pedimos la direccin
      cin.get (Persona.Direccion, 41);                          //...leer hasta 40 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      cout << "Ingrese la ciudad: ";                            //A continuacin, la ciudad...
      cin.get (Persona.Ciudad, 21);                             //...leer hasta 20 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      cout << "Ingrese el telfono: ";                          //Para seguir con el telfono....
      cin.get (Persona.Telefono, 21);                           //...leer hasta 20 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      cout << "Ingrese el fax: ";                               //Tendr fax?....
      cin.get (Persona.Fax, 21);                                //...leer hasta 20 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      cout << "Ingrese el e-mail: ";                            //El medio de comunicacin por excelencia de esta era...
      cin.get (Persona.EMail, 51);                              //...leer hasta 50 chars. + '\0' de la consola
      cin.ignore (256, '\n');
      cout << "Ingrese la ocupacin: ";                         //Pedir la ocupacin...
      cin.get (Persona.Ocupacion, 41);                          //...leer hasta 40 chars. + '\0' de la consola
      cin.ignore (256, '\n');
    }//EndIf
  return (stop);
}//EndPersonaClass::GetData

/***************************************************** MenuGetData *************************************************************/
//Mtodo pblico: MenuGetData: Obtiene los datos a almacenar de la consola, y solicita servicio de almacenaje, arrojando un msj.
//que indica si la operacin tuvo xito o no.
void PersonaClass::MenuGetData()
{
  unsigned short stop,          //Si stop = 1, finalizar con el ingreso de registros
                 i;             //Contador.
  int Resultado;                //Resultado de la llamada al servicio WDataToFile

  do
   {
     system ("clear");
     cout <<"Sub-men de ingreso de nuevos registros. Ingrese cada dato requerido, seguido por ENTER\n\n";
     stop = GetData(0);                                 //Obtener datos por consola
     if (!stop)                                         //Si el usuario ingres datos...
       {
         Resultado = WDataToFile();                     //...escribirlos al archivo.
         if (Resultado == 1)                            //Si !OK con la escritura....
           {
            cout << "\n\n " << Persona.Nombre << " " << Persona.Apellido << " ya se encuentra en la agenda!!";
           }//EndIf
          else                                          //OK al escribir....
            {
              cout << "\n\n Los datos de " << Persona.Nombre << " "<< Persona.Apellido
                   << " han sido exitosamente almacenados en su agenda...";
            }//EndElse
         cin.ignore();
       }//EndIf
   }//EndDoWhile
  while (!stop);                                        //Repetir hasta que el usuario indique que no se ingresarn + datos
}//EndPersonaClass::MenuGetData

/***************************************************** MenuListAll *************************************************************/
//Mtodo pblico: MenuListAll: Lista, en consola, todos los registros contenidos en el archivo de datos, en forma secuencial.
//Tambin se presenta la opcin de borrar el registro que se encuentra en pantalla.
//Precondiciones: El archivo existe.
//Postcondiciones: Si se requiere borrar un registro, ste es eliminado mediante una llamada al servicio DDataFromFile
void PersonaClass::MenuListAll()
{
  long RegNo = 0;               //Registro actual
  long resultado = 0;           //Resultado del servicio de lectura
  char opcion = '1';            //opcin del usuario

  while ((resultado == 0) && (opcion != '0'))                            //Repetir hasta que se acabe el archivo o el usuario frene
    {
      system ("clear");
      cout << "Sub-men de listado secuencial de registros.\n\n";
      resultado = RDataFromFile (0, RegNo, " ", " ");
      if (resultado == -2)                                              //Archivo vaco
        {
          cout << "\n\n\n\tSu agenda est vaca! \n\n\tPresione ENTER para volver al Men Principal...";
          cin.ignore (255, '\n');
        }//EndIf
       else
         if (resultado == -1)                                           //EOF
           {
             cout << "\n\n\n\tNo hay ms registros para mostrar. \n\n\tPresione ENTER para volver al Men Principal...";
             cin.ignore (255, '\n');
           }//EndIf
       else
         {
           ShowData();
           cout << " 1) Mostrar siguiente\n";
           cout << " 2) Mostrar anterior\n";
           cout << " 3) Eliminar registro\n";
           cout << " 4) Modificar registro\n\n";
           cout << " 0) Volver al men principal\n\n";
           cout << " Su opcin: ";
           cin >> opcion;
           cin.ignore (256, '\n');
           if (opcion == '2')           //Se pide mostrar registro anterior
             {
               if (RegNo > 0)
                 RegNo--;
             }
            else
              if (opcion == '3')        //Si se pide eliminar el registro...
                {
                  DDataFromFile(RegNo); //eliminarlo, y dejar RegNo como est, as en la prxima vuelta muestro el siguiente
                  cout << "\n\n\t Registro ELIMINADO... Pulse ENTER para continuar...";
                  cin.ignore (256, '\n');
                }//EndIf
            else
              if (opcion == '4')        //Se pide modificar el registro
                {
                  cout << "\n";
                  GetData(1);           //Obtener datos de la consola
                  MDataInFile (RegNo);  //Modificar el registro en el archivo
                }
            else
              {
                RegNo++;                //Sino, preparar siguiente ciclo
              }//EndElse
         }//EndElse
    }//EndWhile
}//EndPersonaClass::MenuListAll

/***************************************************** MenuListSome ************************************************************/
//Mtodo pblico: MenuListSome: Lista, en consola, todos los registros que cumplen con el criterio de nombre y/o apellido
//Tambin se presenta la opcin de borrar el registro que se encuentra en pantalla.
//Precondiciones: El archivo existe.
//Postcondiciones: Si se requiere borrar un registro, ste es eliminado mediante una llamada al servicio DDataFromFile
void PersonaClass::MenuListSome()
{
  char Apellido[36], Nombre [36];       //Criterios de bsqueda
  long RegNo = 0;                       //Posicin del elemento mostrado
  long ocurrencia;                      //Ocurrencia del dato
  long resultado = 0;                   //Resultado del servicio de lectura
  char opcion = '1';                    //opcin del usuario
  int deleted;                          //Indica que se borraron registros.

  resultado = RDataFromFile (0, 0, " ", " ");
  if (resultado == -2)                                                  //Archivo vaco
    {
      system("clear");
      cout << "\n\n\n\tSu agenda est vaca! \n\n\tPresione ENTER para volver al Men Principal...";
      cin.ignore (255, '\n');
    }//EndIf
   else
    {
      while (opcion != '0')                                             //Repetir hasta que se acabe el archivo o el usuario frene
       {
         system ("clear");
         cout <<"Sub-men de bsqueda de registros por Nombre y/o Apellido.\n\n";
         cout <<"Ingrese el/los criterio(s) de bsqueda. Deje en blanco el criterio que no dese usar\n";
         cout <<"Digite ENTER 2 veces para volver al men principal\n\n";
         cout << "Apellido: ";
         cin.get (Apellido, 36);                                        //Leer hasta 35 chars. + '\0' de la consola
         cin.ignore (256, '\n');
         cout << "Nombre: ";
         cin.get (Nombre, 36);                                          //Leer hasta 35 chars. + '\0' de la consola
         cin.ignore (256, '\n');
         if ((strlen(Apellido) != 0) && (strlen(Nombre) != 0))          //Buscar por ambos criterios
           {
            RegNo = RDataFromFile (1,0,Apellido, Nombre);               //Llamar al servicio y pedirle que busque
            if (RegNo == -1)                                            //Si el registro no est, avisar al usuario...
              {
               cout << "\n\n\tEl registro requerido no se encuentra. Presione ENTER para continuar";
               cin.get ();
              }//EndIf
             else                                                       //Si el registro est...
              {
               ShowData();                                              //...mostrar los datos
               cout << " 1) Realizar otra bsqueda\n";                  //...dar las opciones
               cout << " 2) Eliminar registro\n";
               cout << " 3) Modificar registro\n\n";
               cout << " 0) Volver al men principal\n\n";
               cout << " Su opcin: ";
               cin >> opcion;
               cin.ignore (256, '\n');
               if (opcion == '2')                                       //Si se pide eliminar el registro...
                 {
                   DDataFromFile(RegNo-1);                                //eliminarlo.
                   cout << "\n\n\t Registro ELIMINADO... Pulse ENTER para continuar...";
                   cin.ignore (256, '\n');
                 }//EndIf
                else
                  if (opcion == '3')                                    //Se pide modificar el registro
                    {
                     cout << "\n";
                     GetData(1);                                        //Obtener datos
                     MDataInFile(RegNo-1);                              //Modificar el archivo
                    }//EndElseIf
              }//EndElse
           }//EndIf
          else
            if ((strlen(Apellido) == 0) && (strlen(Nombre) == 0))       //Salir
              {
               opcion = '0';
              }//EndElseIf
          else                                                          //Buscar SOLO por uno de los criterios
            {
             deleted = 0;                                               //Inicialmente no se borr nada
             ocurrencia = 1;                                            //Resetear nmero de ocurrencia
             do
              {
               if (strlen(Nombre) == 0)                                 //Si hay que buscar slo por apellido...
                 {
                   RegNo = RDataFromFile (2,ocurrencia,Apellido, Nombre);
                 }
                else                                                    //Si hay que buscar slo por nombre...
                  {
                    RegNo = RDataFromFile (3,ocurrencia,Apellido, Nombre);
                  }
               if ((RegNo == -1) && ((ocurrencia != 1) || (deleted == 1)))      //Si no hay ms ocurrencias que mostrar...
                 {
                   cout << "\n\n\n\tNo hay ms registros para mostrar. \n\n\tPresione ENTER realizar otra bsqueda...";
                   cin.ignore (255, '\n');
                 }//EndElseIf
                else
                  if ((RegNo == -1) && (ocurrencia == 1))                  //Si no existe el nombre o el apellido...
                    {
                      cout << "\n\n\tEl registro requerido no se encuentra. Presione ENTER para continuar";
                      cin.get ();
                    }
                else                                                    //Si hay datos para mostrar...
                  {
                   system("clear");
                   ShowData();                                          //...mostrarlos...
                   cout << " 1) Siguiente ocurrencia\n";                //...dar las opciones
                   cout << " 2) Realizar otra bsqueda\n";
                   cout << " 3) Eliminar registro\n";
                   cout << " 4) Modificar registro\n\n";
                   cout << " 0) Volver al men principal\n\n";
                   cout << " Su opcin: ";
                   cin >> opcion;
                   cin.ignore (256, '\n');
                   if (opcion == '1')                                   //Si se pidi seguir con otra ocurrencia...
                     {
                       ocurrencia++;
                     }
                    else
                     if (opcion == '3')                                  //Si se pide eliminar el registro...
                       {
                         deleted = 1;
                         DDataFromFile(RegNo-1);                         //eliminarlo.
                         cout << "\n\n\t Registro ELIMINADO... Pulse ENTER para continuar...";
                         cin.ignore (256, '\n');
                         opcion = '1';
                       }//EndElseIf
                    else
                      if (opcion == '4')                                //Se pide modificar el registro
                        {
                          cout << "\n";
                          GetData(1);                                   //Obtener datos
                          MDataInFile(RegNo-1);                         //Modificar el archivo
                          opcion = '1';
                        }//EndElseIf
                  }//EndElse
              }//EndDoWhile
             while ((opcion == '1') && (RegNo != -1));
            }//EndElse
       }//EndWhile
    }//EndElse
}//EndPersonaClass::MenuListSome





